/**************************************************************************

	tdClock

	main.c

	(C) Copyright 2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <Todaycmn.h>
#include <commdlg.h>
#include <aygshell.h>

#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define WINDOW_TITLE			TEXT("tdClock")
#define MAIN_WND_CLASS			TEXT("tdClockWndClass")

#define REG_PATH				TEXT("Software\\tdClock")

#define ID_CLOCK_TIMER			1

#define NUMBMP_CNT				12
#define BUF_SIZE				256


/**************************************************************************
	Global Variables
**************************************************************************/

static HINSTANCE hInst;

static TCHAR numbmpfile[BUF_SIZE];
static TCHAR backbmpfile[BUF_SIZE];
static int view_height = 48;
static int stretch = 0;
static int draw_x = 0;
static int draw_y = 0;
static int stretch_backbmp = 0;

static int show_date = 0;
static TCHAR date_format[BUF_SIZE];
static int date_color = 0;
static int date_x = 160;
static int date_y = 0;

static BOOL Refresh;


/******************************************************************************

	DllMain

	DllMain

******************************************************************************/

BOOL WINAPI DllMain(HINSTANCE hModule, DWORD fdwReason, PVOID pvReserved)
{
	hInst = hModule;
	return TRUE;
}


/******************************************************************************

	GetOption

	ݒ̓ǂݍ

******************************************************************************/

static void GetOption(void)
{
	HKEY hKey;
	DWORD rc;
	DWORD dwType;
	long len;
	long ret;

	lstrcpy(date_format, TEXT("yyyy/MM/dd"));

	if(RegCreateKeyEx(HKEY_CURRENT_USER, REG_PATH, 0, TEXT(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &rc) == ERROR_SUCCESS){
		len = sizeof(TCHAR) * BUF_SIZE;
		ret = RegQueryValueEx(hKey, TEXT("numbmpfile"), NULL, &dwType, (LPBYTE)&numbmpfile, &len);
		len = sizeof(TCHAR) * BUF_SIZE;
		ret = RegQueryValueEx(hKey, TEXT("backbmpfile"), NULL, &dwType, (LPBYTE)&backbmpfile, &len);

		len = sizeof(TCHAR) * BUF_SIZE;
		ret = RegQueryValueEx(hKey, TEXT("date_format"), NULL, &dwType, (LPBYTE)&date_format, &len);

		len = sizeof(int);
		ret = RegQueryValueEx(hKey, TEXT("view_height"), NULL, &dwType, (LPBYTE)&view_height, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, TEXT("stretch"), NULL, &dwType, (LPBYTE)&stretch, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, TEXT("draw_x"), NULL, &dwType, (LPBYTE)&draw_x, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, TEXT("draw_y"), NULL, &dwType, (LPBYTE)&draw_y, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, TEXT("stretch_backbmp"), NULL, &dwType, (LPBYTE)&stretch_backbmp, &len);

		len = sizeof(int);
		ret = RegQueryValueEx(hKey, TEXT("show_date"), NULL, &dwType, (LPBYTE)&show_date, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, TEXT("date_color"), NULL, &dwType, (LPBYTE)&date_color, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, TEXT("date_x"), NULL, &dwType, (LPBYTE)&date_x, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, TEXT("date_y"), NULL, &dwType, (LPBYTE)&date_y, &len);
		RegCloseKey(hKey);
	}
}


/******************************************************************************

	SetOption

	ݒ̕ۑ

******************************************************************************/

static void SetOption(void)
{
	HKEY hKey = 0;
	DWORD rc;

	//WXgɐݒۑ
	if(RegCreateKeyEx(HKEY_CURRENT_USER, REG_PATH, 0, TEXT(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &rc) == ERROR_SUCCESS){
		RegSetValueEx(hKey, TEXT("numbmpfile"), 0, REG_SZ, (LPBYTE)numbmpfile, sizeof(TCHAR) * (lstrlen(numbmpfile) + 1));
		RegSetValueEx(hKey, TEXT("backbmpfile"), 0, REG_SZ, (LPBYTE)backbmpfile, sizeof(TCHAR) * (lstrlen(backbmpfile) + 1));

		RegSetValueEx(hKey, TEXT("date_format"), 0, REG_SZ, (LPBYTE)date_format, sizeof(TCHAR) * (lstrlen(date_format) + 1));

		RegSetValueEx(hKey, TEXT("view_height"), 0, REG_DWORD, (LPBYTE)&view_height, sizeof(int));
		RegSetValueEx(hKey, TEXT("stretch"), 0, REG_DWORD, (LPBYTE)&stretch, sizeof(int));
		RegSetValueEx(hKey, TEXT("draw_x"), 0, REG_DWORD, (LPBYTE)&draw_x, sizeof(int));
		RegSetValueEx(hKey, TEXT("draw_y"), 0, REG_DWORD, (LPBYTE)&draw_y, sizeof(int));
		RegSetValueEx(hKey, TEXT("stretch_backbmp"), 0, REG_DWORD, (LPBYTE)&stretch_backbmp, sizeof(int));

		RegSetValueEx(hKey, TEXT("show_date"), 0, REG_DWORD, (LPBYTE)&show_date, sizeof(int));
		RegSetValueEx(hKey, TEXT("date_color"), 0, REG_DWORD, (LPBYTE)&date_color, sizeof(int));
		RegSetValueEx(hKey, TEXT("date_x"), 0, REG_DWORD, (LPBYTE)&date_x, sizeof(int));
		RegSetValueEx(hKey, TEXT("date_y"), 0, REG_DWORD, (LPBYTE)&date_y, sizeof(int));
		RegCloseKey(hKey);
	}
}


/******************************************************************************

	GetFileName

	t@C̎擾

******************************************************************************/

static BOOL GetFileName(HWND hWnd, TCHAR *ret)
{
	OPENFILENAME of;
	TCHAR path[BUF_SIZE];
	TCHAR *ph;

	lstrcpy(path, ret);
	ZeroMemory(&of, sizeof(OPENFILENAME));
	of.lStructSize = sizeof(OPENFILENAME);
	of.hInstance = hInst;
	of.hwndOwner = hWnd;
	of.lpstrFilter = TEXT("Bitmap (*.bmp)\0*.bmp;*.2bp\0All files (*.*)\0*.*\0\0");
	of.nFilterIndex = 1;
	of.lpstrTitle = TEXT("J");
	of.lpstrFile = path;
	of.nMaxFile = BUF_SIZE - 1;
	of.lpstrDefExt = TEXT("ns");
	of.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	if(GetOpenFileName((LPOPENFILENAME)&of) == FALSE){
		return FALSE;
	}
	ph = path;
	if(*ph == TEXT('\\') && *(ph + 1) == TEXT('\\')){
		ph++;
	}
	if(*(ph + lstrlen(ph)) == TEXT('.')){
		*(ph + lstrlen(ph)) = TEXT('\0');
	}
	lstrcpy(ret, ph);
	return TRUE;
}


/******************************************************************************

	GetColor

	F̑I

******************************************************************************/

static long GetColor(HWND hWnd, long color)
{
	CHOOSECOLOR ch;
	static DWORD ColorTbl[16];

	ZeroMemory(&ch, sizeof(CHOOSECOLOR));
	ch.lStructSize = sizeof(CHOOSECOLOR);
	ch.hwndOwner = hWnd;
	ch.rgbResult = color;
	ch.lpCustColors = ColorTbl;
	ch.Flags = CC_RGBINIT | CC_FULLOPEN;
	/* F̑I */
	if(ChooseColor(&ch) == TRUE){
		return ch.rgbResult;
	}
	return color;
}


/******************************************************************************

	GetTransColor

	F̎擾 (̐F)

******************************************************************************/

static COLORREF GetTransColor(HWND hWnd, HBITMAP hBmp)
{
	HDC hdc;
	HDC mdc;
	HDC memdc;
	HBITMAP hBitMap;
	HBITMAP hRetMemBmp;
	HBITMAP hRetBmp;
	COLORREF TransColor;

	hdc = GetDC(hWnd);

	mdc = CreateCompatibleDC(hdc);
	hRetBmp = SelectObject(mdc, hBmp);

	memdc = CreateCompatibleDC(hdc);
	hBitMap = CreateCompatibleBitmap(hdc, 1, 1);
	hRetMemBmp = SelectObject(memdc, hBitMap);

	BitBlt(memdc, 0, 0, 1, 1, mdc, 0, 0, SRCCOPY);
	TransColor = GetPixel(memdc, 0, 0);

	SelectObject(memdc, hRetMemBmp);
	DeleteObject(hBitMap);
	DeleteDC(memdc);

	SelectObject(mdc, hRetBmp);
	DeleteDC(mdc);

	ReleaseDC(hWnd, hdc);
	return TransColor;
}


/******************************************************************************

	_TransparentBlt

	ߐFgDCRs[

******************************************************************************/

static void _TransparentBlt(HDC todc, int left, int top, int width, int height,
					HDC fromdc, int fleft, int ftop, COLORREF color)
{
	HDC maskDC;
	HBITMAP hMaskBmp;
	HBITMAP hRetMaskBmp;
	HDC tempDC;
	HBITMAP hBmp;
	HBITMAP hRetBmp;

	//Oi̍쐬
	tempDC = CreateCompatibleDC(todc);
	hBmp = CreateCompatibleBitmap(todc, width, height);
	hRetBmp = SelectObject(tempDC, hBmp);
	BitBlt(tempDC, 0, 0, width, height, fromdc, fleft, ftop, SRCCOPY);

	//}XN̍쐬
	maskDC = CreateCompatibleDC(todc);
	hMaskBmp = CreateBitmap(width, height, 1, 1, NULL);
	hRetMaskBmp = SelectObject(maskDC, hMaskBmp);
	SetBkColor(tempDC, color);
	BitBlt(maskDC, 0, 0, width, height, tempDC, 0, 0, SRCCOPY);

	//}XNgđOiwǐ`
	SetBkColor(tempDC, RGB(0, 0, 0));
	SetTextColor(tempDC, RGB(255, 255, 255));
	BitBlt(tempDC, 0, 0, width, height, maskDC, 0, 0, SRCAND);

	///}XNgĔwiOǐ`
	SetBkColor(todc, RGB(255, 255, 255));
	SetTextColor(todc, RGB(0, 0, 0));
	BitBlt(todc, left, top, width, height, maskDC, 0, 0, SRCAND);

	//OiƔwi
	BitBlt(todc, left, top, width, height, tempDC, 0, 0, SRCPAINT);

	SelectObject(maskDC, hRetMaskBmp);
	DeleteObject(hMaskBmp);
	DeleteDC(maskDC);

	SelectObject(tempDC, hRetBmp);
	DeleteObject(hBmp);
	DeleteDC(tempDC);
}


/******************************************************************************

	OnPaint

	̕`

******************************************************************************/

void OnPaint(HWND hWnd, HDC hdc, PAINTSTRUCT *ps, HBITMAP hNumBmp, HBITMAP hBackBmp, int width, int height, COLORREF TransColor)
{
#ifdef _WCE_PPC2002
	TODAYDRAWWATERMARKINFO dwi;
#endif
	HDC drawdc;
	HDC mdc;
	HDC memdc;
	HBITMAP hDrawBitMap;
	HBITMAP hRetDrawBmp;
	HBITMAP hBitMap;
	HBITMAP hRetMemBmp;
	HBITMAP hRetBmp;
	RECT rect;
	SYSTEMTIME systim;
	BITMAP bmp;
	TCHAR buf[BUF_SIZE];
	int x, y;

	//EBhETCYɍ킹rbg}bvi[鉼zEBhE̍쐬
	GetClientRect(hWnd,(LPRECT)&rect);

	//`pzDC
	drawdc = CreateCompatibleDC(hdc);
	hDrawBitMap = CreateCompatibleBitmap(hdc, rect.right, rect.bottom);
	hRetDrawBmp = SelectObject(drawdc, hDrawBitMap);

#ifdef _WCE_PPC2002
	dwi.hdc = drawdc;
	GetClientRect(hWnd, &dwi.rc);
	dwi.hwnd = hWnd;
	SendMessage(GetParent(hWnd), TODAYM_DRAWWATERMARK, 0, (LPARAM)&dwi);
#else
	FillRect(drawdc, &rect, (HBRUSH)GetStockObject(WHITE_BRUSH));
#endif

	//wi̕`
	if(hBackBmp != NULL){
		mdc = CreateCompatibleDC(hdc);
		hRetBmp = SelectObject(mdc, hBackBmp);
		if(stretch_backbmp == 0){
			BitBlt(drawdc, 0, 0, rect.right, rect.bottom, mdc, 0, 0, SRCCOPY);
		}else{
			GetObject(hBackBmp, sizeof(BITMAP), &bmp);
			StretchBlt(drawdc, 0, 0, rect.right, rect.bottom, mdc, 0, 0, bmp.bmWidth, bmp.bmHeight, SRCCOPY);
		}
		SelectObject(mdc, hRetBmp);
		DeleteDC(mdc);
	}

	//t̕`
	if(show_date == 1){
		if(*date_format == TEXT('\0')){
			GetDateFormat(0, 0, NULL, NULL, buf, BUF_SIZE - 1);
		}else{
			GetDateFormat(0, 0, NULL, date_format, buf, BUF_SIZE - 1);
		}
		SetTextColor(drawdc, date_color);
		SetBkMode(drawdc, TRANSPARENT);
		ExtTextOut(drawdc, date_x, date_y, ETO_OPAQUE, NULL, buf, lstrlen(buf), NULL);
	}

	//̎擾
	GetLocalTime(&systim);

	//zDC쐬
	memdc = CreateCompatibleDC(hdc);
	hBitMap = CreateCompatibleBitmap(hdc, width * 5, height);
	hRetMemBmp = SelectObject(memdc, hBitMap);

	//`pzDC
	mdc = CreateCompatibleDC(hdc);
	hRetBmp = SelectObject(mdc, hNumBmp);

	//̏\
	if(systim.wHour / 10 > 0){
		BitBlt(memdc, width * 0, 0, width, height, mdc, (systim.wHour / 10) * width, 0, SRCCOPY);
	}else{
		BitBlt(memdc, width * 0, 0, width, height, mdc, width * 11, 0, SRCCOPY);
	}
	//̈ꌅ
	BitBlt(memdc, width * 1, 0, width, height, mdc, (systim.wHour - systim.wHour / 10 * 10) * width, 0, SRCCOPY);
	//ƕ̋؂
	BitBlt(memdc, width * 2, 0, width, height, mdc, width * 10, 0, SRCCOPY);
	//̏\
	BitBlt(memdc, width * 2 + width, 0, width, height, mdc, (systim.wMinute / 10) * width, 0, SRCCOPY);
	//̈ꌅ
	BitBlt(memdc, width * 3 + width, 0, width, height, mdc, (systim.wMinute - systim.wMinute / 10 * 10) * width, 0, SRCCOPY);

	SelectObject(mdc, hRetBmp);
	DeleteDC(mdc);

	if(stretch == 0){
		switch(draw_x)
		{
		case 0: x = (rect.right - width * 5) / 2; break;
		case -1: x = 0; break;
		case -2: x = rect.right - width * 5; break;
		default: x = draw_x; break;
		}
		switch(draw_y)
		{
		case 0: y = (rect.bottom - height) / 2; break;
		case -1: y = 0; break;
		case -2: y = rect.bottom - height; break;
		default: y = draw_y; break;
		}
		_TransparentBlt(drawdc, x, y, width * 5, height, memdc, 0, 0, TransColor);
	}else{
		TransparentImage(drawdc, 0, 0, rect.right, rect.bottom, memdc, 0, 0, width * 5, height, TransColor);
	}
	BitBlt(hdc, ps->rcPaint.left, ps->rcPaint.top, ps->rcPaint.right, ps->rcPaint.bottom,
		drawdc, ps->rcPaint.left, ps->rcPaint.top, SRCCOPY);

	SelectObject(memdc, hRetMemBmp);
	DeleteObject(hBitMap);
	DeleteDC(memdc);

	SelectObject(drawdc, hRetDrawBmp);
	DeleteObject(hDrawBitMap);
	DeleteDC(drawdc);
}


/******************************************************************************

	WndProc

	CEBhEvV[W

******************************************************************************/

static LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP hNumBmp;
	static HBITMAP hBackBmp;
	static int width;
	static int height;
	static COLORREF TransColor;
	HDC hdc;
	BITMAP bmp;
	PAINTSTRUCT ps;
	SYSTEMTIME systim;

	switch(msg)
	{
	case WM_CREATE:
		if(hNumBmp != NULL){
			DeleteObject(hNumBmp);
			hNumBmp = NULL;
		}
		if(hBackBmp != NULL){
			DeleteObject(hBackBmp);
			hBackBmp = NULL;
		}

		//t@Crbg}bvǂݍ
		if(*numbmpfile != TEXT('\0')){
			hNumBmp = SHLoadDIBitmap(numbmpfile);
		}
		if(hNumBmp == NULL){
			hNumBmp = LoadBitmap(((LPCREATESTRUCT)lParam)->hInstance,
				MAKEINTRESOURCE(IDB_BITMAP));
		}
		if(*backbmpfile != TEXT('\0')){
			hBackBmp = SHLoadDIBitmap(backbmpfile);
		}

		GetObject(hNumBmp, sizeof(BITMAP), &bmp);
		width = bmp.bmWidth / NUMBMP_CNT;
		height = bmp.bmHeight;

		//F̎擾
		TransColor = GetTransColor(hWnd, hNumBmp);

		//^C}[̍쐬
		GetLocalTime(&systim);
		SetTimer(hWnd, ID_CLOCK_TIMER, (systim.wSecond % 10) * 1000, NULL);
		break;

	case WM_DESTROY:
		if(hNumBmp != NULL){
			DeleteObject(hNumBmp);
			hNumBmp = NULL;
		}
		if(hBackBmp != NULL){
			DeleteObject(hBackBmp);
			hBackBmp = NULL;
		}
		return 0;

	case WM_TODAYCUSTOM_CLEARCACHE:
		break;

	case WM_TODAYCUSTOM_QUERYREFRESHCACHE:
		if(Refresh){
			Refresh = FALSE;
			//EBhE̍̐ݒ
			((TODAYLISTITEM *)(wParam))->cyp = view_height;
			return TRUE;
		}
		return FALSE;

	case WM_LBUTTONUP:
	     break;

	case WM_PAINT:
		//`̈̎擾
		hdc = BeginPaint(hWnd, &ps);
		OnPaint(hWnd, hdc, &ps, hNumBmp, hBackBmp, width, height, TransColor);
		EndPaint(hWnd, &ps);
		break;

	case WM_ERASEBKGND:
		return 1;

	case WM_TIMER:
		switch(wParam)
		{
		case ID_CLOCK_TIMER:
			//ĕ`
			InvalidateRect(hWnd, NULL, FALSE);
			UpdateWindow(hWnd);

			KillTimer(hWnd, ID_CLOCK_TIMER);
			GetLocalTime(&systim);
			SetTimer(hWnd, ID_CLOCK_TIMER, (systim.wSecond % 10) * 1000, NULL);
			break;
		}
		break;

	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}


/******************************************************************************

	InitInstance

	EBhE̍쐬

******************************************************************************/

static HWND InitInstance(HWND pWnd, TODAYLISTITEM *ptli)
{
	WNDCLASS wc;

	hInst = ptli->hinstDLL;

	//ݒǂݍ
	GetOption();

	//EBhENX̓o^
    wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.hCursor = 0;
	wc.lpszMenuName = 0;
	wc.lpfnWndProc = (WNDPROC)WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = ptli->hinstDLL;
	wc.hIcon = NULL;
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszClassName = MAIN_WND_CLASS;
	UnregisterClass(MAIN_WND_CLASS, ptli->hinstDLL);
	RegisterClass(&wc);

	Refresh = TRUE;

	//EBhE̍쐬
	return CreateWindow(MAIN_WND_CLASS, WINDOW_TITLE, WS_CHILD | WS_VISIBLE, CW_DEFAULT, CW_DEFAULT, 0, 0,
		pWnd, NULL, ptli->hinstDLL, NULL);
}


/******************************************************************************

	InitializeCustomItem

	

******************************************************************************/

HWND APIENTRY InitializeCustomItem(TODAYLISTITEM *ptli, HWND pWnd)
{
	if(ptli->fEnabled == 0){
		return NULL;
	}
	//EChE̍쐬
	return InitInstance(pWnd, ptli);
}


/******************************************************************************

	DateDlgProc

	t\ݒ

******************************************************************************/

static BOOL CALLBACK DateDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	TCHAR buf[BUF_SIZE];

	switch(uMsg)
	{
	case WM_INITDIALOG:
		//PocketPCp
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
		shidi.hDlg = hDlg;
		SHInitDialog(&shidi);

		SetWindowText(hDlg, TEXT("Show date"));

		//Rg[̏
		SendDlgItemMessage(hDlg, IDC_EDIT_FORMAT, WM_SETTEXT, 0, (LPARAM)date_format);
		SetDlgItemInt(hDlg, IDC_EDIT_X, date_x, FALSE);
		SetDlgItemInt(hDlg, IDC_EDIT_Y, date_y, FALSE);
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_BUTTON_COLOR:
			date_color = GetColor(hDlg, date_color);
			break;

		case IDOK:
			//ݒ̎擾
			SendDlgItemMessage(hDlg, IDC_EDIT_FORMAT, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)date_format);

			*buf = TEXT('\0');
			SendDlgItemMessage(hDlg, IDC_EDIT_X, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)buf);
			date_x = _ttol(buf);
			*buf = TEXT('\0');
			SendDlgItemMessage(hDlg, IDC_EDIT_Y, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)buf);
			date_y = _ttol(buf);
			EndDialog(hDlg, IDOK);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	CustomItemOptionsDlgProc

	ݒ

******************************************************************************/

BOOL APIENTRY CustomItemOptionsDlgProc(HWND hDlg, UINT uMsg, UINT wParam, LONG lParam)
{
	SHINITDLGINFO shidi;
	TCHAR buf[BUF_SIZE];

	switch(uMsg)
	{
	case WM_INITDIALOG:
		//PocketPCp
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
		shidi.hDlg = hDlg;
		SHInitDialog(&shidi);

		SetWindowText(hDlg, TEXT("tdClock"));

		GetOption();

		//Rg[̏
		SetDlgItemInt(hDlg, IDC_EDIT_HEIGHT, view_height, FALSE);
		SendDlgItemMessage(hDlg, IDC_EDIT_NUMBMP, WM_SETTEXT, 0, (LPARAM)numbmpfile);
		SendDlgItemMessage(hDlg, IDC_EDIT_BACKBMP, WM_SETTEXT, 0, (LPARAM)backbmpfile);
		SendDlgItemMessage(hDlg, IDC_CHECK_STRETCH, BM_SETCHECK, stretch, 0);
		SetDlgItemInt(hDlg, IDC_EDIT_X, draw_x, FALSE);
		SetDlgItemInt(hDlg, IDC_EDIT_Y, draw_y, FALSE);
		SendDlgItemMessage(hDlg, IDC_CHECK_STRETCHBACK, BM_SETCHECK, stretch_backbmp, 0);
		SendDlgItemMessage(hDlg, IDC_CHECK_DATE, BM_SETCHECK, show_date, 0);

		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_X), !stretch);
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_Y), !stretch);
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_CHECK_STRETCH:
			//Enable switch
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT_X),
				!SendDlgItemMessage(hDlg, IDC_CHECK_STRETCH, BM_GETCHECK, 0, 0));
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT_Y),
				!SendDlgItemMessage(hDlg, IDC_CHECK_STRETCH, BM_GETCHECK, 0, 0));
			break;

		case IDC_BUTTON_NUMBMP:
			//rbg}bv̑I
			*buf = TEXT('\0');
			if(GetFileName(hDlg, buf) == FALSE){
				break;
			}
			SendDlgItemMessage(hDlg, IDC_EDIT_NUMBMP, WM_SETTEXT, 0, (LPARAM)buf);
			break;

		case IDC_BUTTON_BACKBMP:
			//rbg}bv̑I
			*buf = TEXT('\0');
			if(GetFileName(hDlg, buf) == FALSE){
				break;
			}
			SendDlgItemMessage(hDlg, IDC_EDIT_BACKBMP, WM_SETTEXT, 0, (LPARAM)buf);
			break;

		case IDC_CHECK_DATE:
			if(SendDlgItemMessage(hDlg, IDC_CHECK_DATE, BM_GETCHECK, 0, 0) == 1){
				DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_DATE), hDlg, DateDlgProc, 0);
			}
			break;

		case IDC_BUTTON_UNINSTALL:
			if(MessageBox(hDlg, TEXT("Delete tdClock information?"), TEXT("Uninstall"), MB_ICONSTOP | MB_OKCANCEL) == IDOK){
				//WXg̍폜
				RegDeleteKey(HKEY_CURRENT_USER, REG_PATH);
			}
			if(MessageBox(hDlg, TEXT("Delete today information?"), TEXT("Uninstall"), MB_ICONSTOP | MB_OKCANCEL) == IDOK){
				//todayWXg̍폜
				RegDeleteKey(HKEY_LOCAL_MACHINE, TEXT("Software\\Microsoft\\Today\\Items\\tdClock"));
				MessageBox(hDlg, TEXT("Information was deleted. Please uninstall."), TEXT("Info"), MB_OK | MB_ICONINFORMATION);
			}
			EndDialog(hDlg, IDOK);
			break;

		case IDOK:
			//ݒ̎擾
			view_height = GetDlgItemInt(hDlg, IDC_EDIT_HEIGHT, NULL, FALSE);
			SendDlgItemMessage(hDlg, IDC_EDIT_NUMBMP, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)numbmpfile);
			SendDlgItemMessage(hDlg, IDC_EDIT_BACKBMP, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)backbmpfile);
			stretch = SendDlgItemMessage(hDlg, IDC_CHECK_STRETCH, BM_GETCHECK, 0, 0);
			stretch_backbmp = SendDlgItemMessage(hDlg, IDC_CHECK_STRETCHBACK, BM_GETCHECK, 0, 0);
			show_date = SendDlgItemMessage(hDlg, IDC_CHECK_DATE, BM_GETCHECK, 0, 0);

			*buf = TEXT('\0');
			SendDlgItemMessage(hDlg, IDC_EDIT_X, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)buf);
			draw_x = _ttol(buf);
			*buf = TEXT('\0');
			SendDlgItemMessage(hDlg, IDC_EDIT_Y, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)buf);
			draw_y = _ttol(buf);

			SetOption();

			EndDialog(hDlg, IDOK);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}
/* End of source */
